//
// Generated by JTB 1.3.2
//

package org.ow2.mind.st.templates.jtb.visitor;
import org.ow2.mind.st.templates.jtb.syntaxtree.*;
import java.util.*;

/**
 * Provides default methods which visit each node in the tree in depth-first
 * order.  Your visitors may extend this class.
 */
public class DepthFirstVisitor implements Visitor {
   //
   // Auto class visitors--probably don't need to be overridden.
   //
   public void visit(NodeList n) {
      for ( Enumeration<Node> e = n.elements(); e.hasMoreElements(); )
         e.nextElement().accept(this);
   }

   public void visit(NodeListOptional n) {
      if ( n.present() )
         for ( Enumeration<Node> e = n.elements(); e.hasMoreElements(); )
            e.nextElement().accept(this);
   }

   public void visit(NodeOptional n) {
      if ( n.present() )
         n.node.accept(this);
   }

   public void visit(NodeSequence n) {
      for ( Enumeration<Node> e = n.elements(); e.hasMoreElements(); )
         e.nextElement().accept(this);
   }

   public void visit(NodeToken n) { }

   //
   // User-generated visitor methods below
   //

   /**
    * <PRE>
    * f0 -> &lt;TEMPLATE&gt;
    * f1 -> FullyQualifiedName()
    * f2 -> [ SuperTemplateDefinition() ]
    * f3 -> [ ImplementsDefinitions() ]
    * f4 -> &lt;LBRACE&gt;
    * f5 -> RequiresDefinitions()
    * f6 -> &lt;INLINED_CODE&gt;
    * f7 -> &lt;RBRACE&gt;
    * </PRE>
    */
   public void visit(TemplateComponentDefinition n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      n.f5.accept(this);
      n.f6.accept(this);
      n.f7.accept(this);
   }

   /**
    * <PRE>
    * f0 -> &lt;COLON&gt;
    * f1 -> FullyQualifiedName()
    * </PRE>
    */
   public void visit(SuperTemplateDefinition n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * <PRE>
    * f0 -> &lt;IMPLEMENTS&gt;
    * f1 -> FullyQualifiedName()
    * f2 -> ( &lt;COMMA&gt; FullyQualifiedName() )*
    * </PRE>
    */
   public void visit(ImplementsDefinitions n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
   }

   /**
    * <PRE>
    * f0 -> ( FullyQualifiedName() &lt;IDENTIFIER&gt; &lt;ASSIGN&gt; ( ( &lt;PLUGIN&gt; &lt;LPAREN&gt; FullyQualifiedName() &lt;RPAREN&gt; ) | FullyQualifiedName() ) &lt;SEMICOLON&gt; )*
    * </PRE>
    */
   public void visit(RequiresDefinitions n) {
      n.f0.accept(this);
   }

   /**
    * <PRE>
    * f0 -> &lt;IDENTIFIER&gt;
    * f1 -> ( &lt;DOT&gt; &lt;IDENTIFIER&gt; )*
    * </PRE>
    */
   public void visit(FullyQualifiedName n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

}
