//
// Generated by JTB 1.3.2
//

package org.ow2.mind.st.templates.jtb.visitor;
import org.ow2.mind.st.templates.jtb.syntaxtree.*;
import java.util.*;

/**
 * Provides default methods which visit each node in the tree in depth-first
 * order.  Your visitors may extend this class.
 */
public class GJDepthFirst<R,A> implements GJVisitor<R,A> {
   //
   // Auto class visitors--probably don't need to be overridden.
   //
   public R visit(NodeList n, A argu) {
      R _ret=null;
      int _count=0;
      for ( Enumeration<Node> e = n.elements(); e.hasMoreElements(); ) {
         e.nextElement().accept(this,argu);
         _count++;
      }
      return _ret;
   }

   public R visit(NodeListOptional n, A argu) {
      if ( n.present() ) {
         R _ret=null;
         int _count=0;
         for ( Enumeration<Node> e = n.elements(); e.hasMoreElements(); ) {
            e.nextElement().accept(this,argu);
            _count++;
         }
         return _ret;
      }
      else
         return null;
   }

   public R visit(NodeOptional n, A argu) {
      if ( n.present() )
         return n.node.accept(this,argu);
      else
         return null;
   }

   public R visit(NodeSequence n, A argu) {
      R _ret=null;
      int _count=0;
      for ( Enumeration<Node> e = n.elements(); e.hasMoreElements(); ) {
         e.nextElement().accept(this,argu);
         _count++;
      }
      return _ret;
   }

   public R visit(NodeToken n, A argu) { return null; }

   //
   // User-generated visitor methods below
   //

   /**
    * <PRE>
    * f0 -> &lt;TEMPLATE&gt;
    * f1 -> FullyQualifiedName()
    * f2 -> [ SuperTemplateDefinition() ]
    * f3 -> [ ImplementsDefinitions() ]
    * f4 -> &lt;LBRACE&gt;
    * f5 -> RequiresDefinitions()
    * f6 -> &lt;INLINED_CODE&gt;
    * f7 -> &lt;RBRACE&gt;
    * </PRE>
    */
   public R visit(TemplateComponentDefinition n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      n.f6.accept(this, argu);
      n.f7.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;COLON&gt;
    * f1 -> FullyQualifiedName()
    * </PRE>
    */
   public R visit(SuperTemplateDefinition n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;IMPLEMENTS&gt;
    * f1 -> FullyQualifiedName()
    * f2 -> ( &lt;COMMA&gt; FullyQualifiedName() )*
    * </PRE>
    */
   public R visit(ImplementsDefinitions n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> ( FullyQualifiedName() &lt;IDENTIFIER&gt; &lt;ASSIGN&gt; ( ( &lt;PLUGIN&gt; &lt;LPAREN&gt; FullyQualifiedName() &lt;RPAREN&gt; ) | FullyQualifiedName() ) &lt;SEMICOLON&gt; )*
    * </PRE>
    */
   public R visit(RequiresDefinitions n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * <PRE>
    * f0 -> &lt;IDENTIFIER&gt;
    * f1 -> ( &lt;DOT&gt; &lt;IDENTIFIER&gt; )*
    * </PRE>
    */
   public R visit(FullyQualifiedName n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

}
